#ifndef DICTIONARY
#define DICTIONARY

template <class Key, class Item> 
class Dictionary
{
   public:

      Dictionary()

      {
         uniqueKey = true; // unique keys is the default.
      }
      
      Dictionary(bool v)

      {
         uniqueKey = v;
      };

      virtual bool insert(Key& key, Item& item) = 0;

      virtual Item* find(Key& key) = 0;

      virtual void remove(Key& key) = 0;

      virtual void removeAll(Key& key) = 0;

      inline bool hasUniqueKeys()

      {
         return uniqueKey;
      };


   private:

      bool uniqueKey;
};

template <class Key, class Item>
struct Association

{
   public:

      Key* pkey;
      Item* pitem;
};

#endif //ABS_DICTIONARY

