#ifndef LISTDICTIONARY
#define LISTDICTIONARY
/*
   file: ListDictionary.h

   Provides an implementation using a list of a Dictionary object.

   Revision History:

   Creation - May 12, 2003 by M. Jansen.
*/

#include "Dictionary.h"

/*
   The ListDictionary class is a list based implementation
   of a Dictionary. See Dictionary.h for explanation of 
   the Dictionary datastructure, and description of the 
   methods.
*/ 
template <class Key, class Item>
class ListDictionary : public virtual Dictionary<Key, Item>
{
   public:

      /*
         See Dictionary.h for description of the following methods:
      */
  
      ListDictionary();

      ListDictionary(bool v);

      bool insert(Key& key, Item& item);

      Item* find(Key& key);

      void remove(Key& key);

      void removeAll(Key&);

      ~ListDictionary();

   protected:
      
      class ListItem 
      /*
         purpose : A listItem is a link in a singly linked list.
      */
      {
         public:

            ~ListItem()
            /*
                purpose : destruct ListItem and associated data.
             */
            {
               delete key;
               delete item;
            }
       
            Key* key;
            Item* item;
            ListItem* next;
      };

      ListItem* head;
};
#endif
         
