/* Created by Anjuta version 1.1.1 */
/*	This file will not be overwritten */


/* Author - Greg Davey */

#include <iostream>//needed for I/O
#include <string>//needed for strings
#include <fstream>//needed for file I/O
#include <cstdlib>//needed for exit() and exit consts
#include <list>//needed for list
#include "supply.h"//needed for allocateDictionary()
#include "Dictionary.h"//needed for Dictionary
#include <cctype>//needed for isalpha()
using namespace std;

Dictionary<string, int>* _dic = allocateDictionary(true, string(), 1);
string _file1, _file2;
ifstream _readFile;
list<string> _keys;

//maybe an Integer wrapper class





void garbageCollect(){
	/*
	purpose - do neccessary garbage collection
	result - no memory leaks
	*/
	deallocateDictionary(_dic);
	delete _dic;
	//_keys.~list<string>();
	_file1.~string();
	_file2.~string();
	_readFile.~ifstream();
}

bool nextString(string* tmp){
  /*
    purpose - reads the next alpha string in the input stream
    result - changes the value of the string pointed to by *tmp
    return - true if not at EOF false if at EOF
  */
  char c;
  while (_readFile.get(c)){
    if (isalpha(c)){
      *tmp += c;
    } else {
      //cout << "next word: " << *tmp << "\n";
      return true;
    }
  }
  return false;
}

void getKeys(){
  /*
    purpose - fills dictionary with all possible keys(alpha strings)
    and sets initial item value to 0
    result - dictionary with keys of all possible words in the first
    file listed.
  */
  string str = string();
  string* strpointer = &str;
  while (nextString(strpointer)){
    if (str != string() && _dic->find(str) == NULL){
      //cout << "inserting " << str << "\n";
      int i = 0;
      _dic->insert(str, i);
      _keys.push_back(str);
    }
    str = string();
  }
  _readFile.close();
  delete strpointer;
  str.~string();
}

bool openFile(string file){
  /*
    purpose - open the (string file) for file I/O
    result - _readFile now reads from the (string file)
    returns - true if file open was succesful
  */
  //cout << "Opening :" << file.c_str() << "\n";
  _readFile.open(file.c_str());
  _readFile.seekg(std::ios::beg);
  return (_readFile);
}

void addWord(string tmp){
  /*
    purpose - determine if the input string exists as a key in the
    dictionary then increment the counter by one if it does.
    result - accurate count of recurring words from first file.
  */
  int* exist = _dic->find(tmp);
  if (exist != NULL){
    *exist = *exist + 1;
  }
}

int* occurrences(string tmp){
  /*
    purpose - allow easy access to the int* item the Dictionary
    contains
    result - makes no modifications.
    returns - int* the dictionary maps to the (String tmp)
  */
  return _dic->find(tmp);
}

void countInFile2(){
  /*
    purpose - fills dictionary with all possible keys(alpha strings)
    and sets initial item value to 0
    result - dictionary with keys of all possible words in the first
    file listed.
  */
  string str = string();
  string* strpointer = &str;
  while (nextString(strpointer)){
    addWord(str);
    str=string();
  }
  _readFile.close();
  delete strpointer;
  str.~string();
}

void toString(){
  /*
    purpose - prints out the results of the search
    result - stuff gets printed to the screen
    returns - a big fat void
    todo - change to recursive returning a string
  */
  list<string>::iterator pos = _keys.begin();
  while (pos != _keys.end()){
    cout << *pos << " : " << *occurrences(*pos) << "\n";
    ++pos;
  }
  
}

int main(int argc,char* argv[]){
  if (argc == 3){
    _file1=argv[1];
    _file2=argv[2];
    if (! openFile(_file1)){
      cout << "File open failure\n";
      return(EXIT_FAILURE);
    }
    getKeys();
    if (! openFile(_file2)){
      cout << "File open failure\n";
      return(EXIT_FAILURE);
    }
    countInFile2();
    toString();
    garbageCollect();
    return (EXIT_SUCCESS);
  } else{
    cout << "Usage:\n" << "count [file1] [file2]\n";
    return (EXIT_FAILURE);
  }
}
